#include <iostream>

using namespace std;

int main()
{
    int p[200050], n, k, a, c, x, imax, r=1;
    long long s=0, smax=0, sa=0;
    bool t=true;
    cin >> n >> k >> x;
    for(int i=0; i<n; i++)
        cin >> p[i];
    //ok sta ja sad s to da radim
    if(x==2)
    {
        for(int i=0; i<n-k+1; i++)
        {
            c=1;
            a=0;
            for(int j=k+i-1; j>i; j--)
            {
                s+=p[j];
                if(s>smax)
                {
                    smax=s;
                }
            }
            cout << s+p[i]+smax << " ";
            s=0;
            smax=0;
        }
    }
    for(int i=0;i<n;i++)
    {
        if(p[i]<0)
            t=false;
    }
    if(t)
    {
        for(int i=0; i<k; i++)
        {

            s+=p[i]*r;
            if(r<x)
            {
                r++;
                sa+=p[i];
            }
        }
        cout << s;
        for(int i=1; i<n-k+1; i++)
        {
            cout << s-sa+x*p[k+i-1];
            sa=sa-p[i-1]+p[k+i-1];
        }
    }




    /*for(int i=0; i<n; i++)
    {
        c=1;
        a=0;
        for(int j=i; j<k+i; j++)
        {
            if(a[j+1]>0)
            {

            }
        }
    }*/
    return 0;
}
/*
Sta da radim ja
kada mi neko
banuje Jasua
I zato
sto si uradio to
sada ce
te suportovati Teemo

Banovase Jasua
uneli mi dramu
zb

al ne kao fr sta radim ja ovde kako sam ja ovde zavrsio uopste mislim da je to tipa skroz validno piranje
i zasto vasa litteraly aura farmuje (praying_hands)

ne mogu bre ja vise ovako sto ja sedim ovde
ladno mi je iz nekog razloga sunce hoce da me ubije povraca mi se umrecu uskoro vrv sta je ovo vise sta ovo treba da znaci

ne znam zapravo sto i dalje sedim ovde al mene stvarno infinitley(ta rec se ne pise tako) mrzi da radim ove stvari

sto se kaze ti imas gomilu tih nekih malih koji se trkaju, znas koje su sanse da se ti rodis, abnormalno male

e isto rodjendani su social construct to mozda nisam reko

jos jedan note ja cu da poludim mnogo je teze da drzimglavu uspravno nego da se kao covek naslonim na klupu i soavam msm stvarno kakvo je ovo ponasanje i bad design

tipa zadnjih 20 minuta mislim da nisam ni pomislio ni na jedan zadatak sto ja sedim ovde
*/